Globalization in EJ2 JavaScript DateTime Picker

04 Sep 202614 minutes to read

Globalization is the combination of internationalization and localization. The component can be adapted to various languages by parsing and formatting the date or number, known as Internationalization, and also by adding culture specific customization and translation to the text, known as Localization.

By default, the date format, week, month, time format and meridian names are specific to the American English culture. It utilizes the
Essential® JavaScript 2 Internationalization package to parse and format the date object based on the culture by using the official UNICODE CLDR JSON data. It provides the loadCldr method to load culture specific CLDR JSON data. To use a different culture other than English, follow the steps below:

  • Install the CLDR-Data package by using the following command (installs all the CLDR JSON data). To know more about CLDR-Data, refer to the CLDR-Data link.
npm install cldr-data --save

Once the package is installed, the culture specific JSON data can be found under the location /node_modules/cldr-data.

  • Import the installed CLDR JSON data into the app.ts file. To import JSON data, install the JSON plugin loader. Here, the SystemJS JSON plugin loader is used.
npm install systemjs-plugin-json --save-dev
  • After installation, configure the system.config.js configuration settings as given below to map the
    systemjs-plugin-json loader.
System.config({
    paths: {
        'npm:': './node_modules/',
        'syncfusion:': 'npm:@syncfusion/'

    },
    map: {
        app: 'app',

        //Syncfusion packages mapping
        "@syncfusion/ej2-base": "syncfusion:ej2-base/dist/ej2-base.umd.min.js",
        "@syncfusion/ej2-data": "syncfusion:ej2-data/dist/ej2-data.umd.min.js",
        "@syncfusion/ej2-inputs": "syncfusion:ej2-inputs/dist/ej2-inputs.umd.min.js",
        "@syncfusion/ej2-splitbuttons": "syncfusion:ej2-splitbuttons/dist/ej2-splitbuttons.umd.min.js",
        "@syncfusion/ej2-popups": "syncfusion:ej2-popups/dist/ej2-popups.umd.min.js",
        "@syncfusion/ej2-lists": "syncfusion:ej2-lists/dist/ej2-lists.umd.min.js",
        "@syncfusion/ej2-buttons": "syncfusion:ej2-buttons/dist/ej2-buttons.umd.min.js",
        "@syncfusion/ej2-calendars": "syncfusion:ej2-calendars/dist/ej2-calendars.umd.min.js",
        "cldr-data": 'npm:cldr-data',
        "plugin-json": "npm:systemjs-plugin-json/json.js"
    },
    meta: {
        '*.json': { loader: 'plugin-json' }
    },
    packages: {
        'app': { main: 'app', defaultExtension: 'js' },
        'cldr-data': { main: 'index.js', defaultExtension: 'js' }
    }
});

System.import('app');
  • Use the loadCldr method to load the culture specific CLDR JSON data from the installed location to app.ts file.

  • The DateTime Picker displays Sunday as the first day of week based on the default culture (“en-US”). To display the DateTime Picker with the loaded culture’s first day of week, the weekdata.json file needs to be imported from cldr-data/supplemental as given in the code example.

import { loadCldr } from '@syncfusion/ej2-base';

declare var require: any;

loadCldr(
    require('cldr-data/main/de/ca-gregorian.json'),
    require('cldr-data/main/de/numbers.json'),
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/de/timeZoneNames.json'),
    require('cldr-data/supplemental/weekdata.json') // To load the culture based first day of week
);

The Localization library allows localizing the default text content of the DateTime Picker. The DateTime Picker component has static text for the today feature that can be changed to other cultures (Arabic, Deutsch, French, etc.) by defining the locale value and translation object.

Locale keywords Text
today Name of the button to choose Today date.
placeholder Hint to describe expected value in input element.
  • Before changing to a culture other than English, ensure that locale text for the concerned culture is loaded through the load method of the L10n class.
//Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';

//load the locale object to set the localized placeholder value
L10n.load({
    'de': {
        'datetimepicker': {
            placeholder: 'Wählen Sie ein Datum und eine Uhrzeit aus',
            today:'heute'
        }
    }
});
  • Set the culture by using the locale property. In the following code example, the DateTime Picker is initialized in German culture with the corresponding localized text.

The following example demonstrates the DateTime Picker in German culture.

ej.base.enableRipple(true);
  
  var L10n = ej.base.L10n;

 L10n.load({
    'de': {
        'datetimepicker': {
           placeholder:'Wählen Sie ein Datum und eine Uhrzeit aus',
           today:'heute'
        }
    }});

     loadCultureFiles('de');
       var datetimepicker = new ej.calendars.DateTimePicker({
       locale: 'de'
    });
    datetimepicker.appendTo('#element');

  function loadCultureFiles(name) {
        var files = ['ca-gregorian.json', 'numbers.json', 'timeZoneNames.json'];
        var loader = ej.base.loadCldr;
        var loadCulture = function (prop) {
            var val, ajax;
            ajax = new ej.base.Ajax('https://ej2.syncfusion.com/javascript/demos/' + 'src/common/cldr-data/main/' + name + '/' + files[prop], 'GET', false);
            ajax.onSuccess = function (value) {
                val = value;
            };
            ajax.send();
            loader(JSON.parse(val));
        };
        for (var prop = 0; prop < files.length; prop++) {
            loadCulture(prop);
        }
    }
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 DateRangePicker control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="styles.css" rel="stylesheet">
    <!--style reference from the DateTimePicker component-->
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-calendars/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input id="element">
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Right-To-Left

The DateTime Picker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to display the text in the right-to-left direction. Use the enableRtl property to set the RTL direction. The following code example initializes the DateTime Picker component in Arabic culture and also explains how to set the localized text to the placeholder using the load method of
the L10n class.

ej.base.enableRipple(true);
 var L10n = ej.base.L10n;

 L10n.load({
    'ar': {
         'datetimepicker': {
            placeholder: 'حدد التاريخ والوقت',
            today: 'اليوم'
        }
    }});

     loadCultureFiles('ar');
       var datetimepicker = new ej.calendars.DateTimePicker({
       locale: 'ar'
    });
    datetimepicker.appendTo('#element');

  function loadCultureFiles(name) {
        var files = ['ca-gregorian.json', 'numbers.json', 'timeZoneNames.json'];
         if (name === 'ar') {
            files.push('numberingSystems.json');
        }
        var loader = ej.base.loadCldr;
         var loadCulture = function (prop) {
            var val, ajax;
            if (name === 'ar' && prop === files.length - 1) {
                ajax = new ej.base.Ajax('https://ej2.syncfusion.com/javascript/demos/src/common/cldr-data/supplemental/' + files[prop], 'GET', false);
            } else {
                ajax = new ej.base.Ajax('https://ej2.syncfusion.com/javascript/demos/src/common/cldr-data/main/' + name + '/' + files[prop], 'GET', false);
            }
            ajax.onSuccess = function (value) {
                val = value;
            };
            ajax.send();
            loader(JSON.parse(val));
        };
        for (var prop = 0; prop < files.length; prop++) {
            loadCulture(prop);
        }
    }
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 DateRangePicker control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="styles.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input id="element">
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Globalization in React DateTime Picker

04 Sep 202616 minutes to read

Globalization enables components to support multiple languages and regional formats. This combines Internationalization (parsing and formatting dates and times according to regional standards) with localization (translating text and applying culture-specific customizations).

By default, the React DateTime Picker uses American English culture for date format, week names, month names, time format, and meridian names. It leverages the Essential® JavaScript 2 Internationalization package with official UNICODE CLDR JSON data to parse and format dates and times according to the selected culture.

Quick Start: Enable a Different Culture

To display the React DateTime Picker in a culture other than English, follow these steps:

  • Install the CLDR-Data package by using the following command (installs all the CLDR JSON data). To know more about CLDR-Data refer to the CLDR-Data link.

       npm install cldr-data --save
    

    Once the package is installed, the culture specific JSON data can be found under the location \node_modules\cldr-data.

  • Import the installed CLDR JSON data into the app.ts file.

  • Use the loadCldr method to load the culture specific CLDR JSON data from the installed location to app.ts file.

  • React DateTime Picker displays Sunday as the first day of week based on default culture (“en-US”). To display the React DateTime Picker with loaded culture’s first day of week, import the weekdata.json file from the cldr-data/supplemental folder as given in the code example.

import { loadCldr } from '@syncfusion/ej2-base';

import { loadCldr } from "@syncfusion/ej2-base";

import * as gregorian from 'cldr-data/main/de/ca-gregorian.json';
import * as numbers from 'cldr-data/main/de/numbers.json';
import * as timeZoneNames from 'cldr-data/main/de/timeZoneNames.json';
import * as numberingSystems from 'cldr-data/supplemental/numberingSystems.json';
import * as weekData from 'cldr-data/supplemental/weekData.json';// To load the culture based first day of week

loadCldr(numberingSystems, gregorian, numbers, timeZoneNames, weekData);

If the error /node_modules/cldr-data/main/de/*.json (1,1): unused expression, expected an assignment or function call is encountered when adding the JSON files to render the culture sample, add the below configuration in the tslint.json file.

"linterOptions": {
    "exclude": [
      "*.json",
      "**/*.json"
    ]
  }

Localization

The Localization library provides the ability to localize default text content of the React DateTime Picker. The React DateTime Picker component has static text for the today feature that can be changed to other cultures (Arabic, Deutsch, French, etc.) by defining the locale value and translation object.

Locale keywords Text
today Name of the button to choose Today date.
placeholder Hint to describe expected value in input element.
  • Before changing to a culture other than English, ensure that locale text for the target culture is loaded through the load method of the L10n class.

       //Load the L10n from ej2-base
        import { L10n } from '@syncfusion/ej2-base';
    
        //load the locale object to set the localized placeholder value
         L10n.load({
           'de': {
             'datetimepicker': {
               placeholder: 'Wählen Sie ein Datum und eine Uhrzeit aus',
               today:'heute'
             }
          }
      });

Locale texts can also be obtained from the ej2-locale repository. The repository contains a comprehensive collection of locale-specific resources that can be used to customize the React DateTime Picker component for different cultures. Refer to the Localization topic for more information on how to use locale texts from the repository.

  • Set the culture by using the locale property. In the following code example, the React DateTime Picker is initialized in German culture with corresponding localized text.

The following example demonstrates the React DateTime Picker in German culture.

[Class-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
    'de': {
        'datetimepicker': {
            placeholder: 'Wählen Sie ein Datum und eine Uhrzeit aus',
            today: 'heute'
        }
    }
});
class App extends React.Component {
    dateValue = new Date("12/11/2017 1:00 AM");
    render() {
        return <DateTimePickerComponent id="datetimepicker" value={this.dateValue} locale='de'/>;
    }
}
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';

loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);

L10n.load({
  'de': {
    'datetimepicker': {
        placeholder:'Wählen Sie ein Datum und eine Uhrzeit aus',
        today:'heute'
    }
  }
});

class App extends React.Component<{}, {}> {

    private dateValue: Date = new Date("12/11/2017 1:00 AM");

    render() {
        return <DateTimePickerComponent id="datetimepicker" value={this.dateValue} locale='de'/>;
    }
}
ReactDOM.render(<App />, document.getElementById('element'));

[Functional-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
    'de': {
        'datetimepicker': {
            placeholder: 'Wählen Sie ein Datum und eine Uhrzeit aus',
            today: 'heute'
        }
    }
});
function App() {
    const dateValue = new Date("12/11/2017 1:00 AM");
    return <DateTimePickerComponent id="datetimepicker" value={dateValue} locale='de'/>;
}
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';

loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);

L10n.load({
  'de': {
    'datetimepicker': {
        placeholder:'Wählen Sie ein Datum und eine Uhrzeit aus',
        today:'heute'
    }
  }
});

function App(){

    const dateValue: Date = new Date("12/11/2017 1:00 AM");
        return <DateTimePickerComponent id="datetimepicker" value={dateValue} locale='de'/>;
}
ReactDOM.render(<App />, document.getElementById('element'));

Right-To-Left

The React DateTime Picker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to display text in the right-to-left direction. Use the enableRtl property to set the RTL direction.
The following code example initializes the React DateTime Picker component in Arabic culture and also demonstrates how to set the localized text to the placeholder using the load method of the L10n class.

[Class-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
    'ar': {
        'datetimepicker': {
            placeholder: 'حدد التاريخ والوقت',
            today: 'اليوم'
        }
    }
});
class App extends React.Component {
    render() {
        return <DateTimePickerComponent id="datetimepicker" enableRtl={true} locale='ar'/>;
    }
}
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
   'ar': {
        'datetimepicker': {
            placeholder: 'حدد التاريخ والوقت',
            today: 'اليوم'
        }
    }
});

class App extends React.Component<{}, {}> {

    render() {
        return <DateTimePickerComponent id="datetimepicker" enableRtl={true} locale='ar'/>
    }
}
ReactDOM.render(<App />, document.getElementById('element'));

[Functional-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
    'ar': {
        'datetimepicker': {
            placeholder: 'حدد التاريخ والوقت',
            today: 'اليوم'
        }
    }
});
function App() {
    return <DateTimePickerComponent id="datetimepicker" enableRtl={true} locale='ar'/>;
}
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
// Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
// load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
   'ar': {
        'datetimepicker': {
            placeholder: 'حدد التاريخ والوقت',
            today: 'اليوم'
        }
    }
});

function App() {

    return <DateTimePickerComponent id="datetimepicker" enableRtl={true} locale='ar'/>
}
ReactDOM.render(<App />, document.getElementById('element'));

Globalization in Vue DateTimePicker

20 Aug 202610 minutes to read

Globalization is the combination of internalization and localization. You can adapt the component to various languages by parsing and formatting the date or number Internationalization, and also add culture specific customization and translation to the text localization.

By default, the date format, week, month, time format and meridian names are specific to the American English culture. It utilizes the Essential® JavaScript 2 Internationalization package to parse and format the date object based on the culture by using the official UNICODE CLDR JSON data. It provides the loadCldr method to load culture specific CLDR JSON data. To use a different culture other than English, follow the steps below:

  • Install the CLDR-Data package by using the following command (installs all the CLDR JSON data). To know more about CLDR-Data refer to the CLDR-Data link.

    npm install cldr-data --save
    

Once the package is installed, you can find the culture specific JSON data under the location /node_modules/cldr-data.

  • Import the installed CLDR JSON data into the app.vue file.

  • Use the loadCldr method to load the culture specific CLDR JSON data
    from the installed location to app.vue file.

  • DateTimePicker displayed Sunday as the first day of week based on default culture (“en-US”). If you want to display the DateTimePicker with loaded culture’s first day of week, you need to import weekdata.json file from the cldr-data/suppemental as given in the code example.

//Load the loadCldr from ej2-base
import { loadCldr } from '@syncfusion/ej2-base';

import * as numberingSystems from 'cldr-data/supplemental/numberingSystems.json';
import * as gregorian from 'cldr-data/main/de/ca-gregorian.json';
import * as numbers from 'cldr-data/main/de/numbers.json';
import * as timeZoneNames from 'cldr-data/main/de/timeZoneNames.json';
import * as weekData from 'cldr-data/supplemental/weekdata.json';// To load the culture based first day of week

loadCldr(numberingSystems, gregorian, numbers, timeZoneNames, weekData);

The Localization library allows you to localize default text content of the DateTimePicker. The DateTimePicker component has static text for today feature that can be changed to other cultures (Arabic, Deutsch, French, etc.) by defining the locale value and translation object.

Locale keywords Text
today Name of the button to choose Today date.
placeholder Hint to describe expected value in input element.
  • Before changing to a culture other than English, ensure that locale text for the concerned culture is loaded through load method of
    L10n class.
//Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';

//load the locale object to set the localized placeholder value
L10n.load({
    'de': {
        'datetimepicker': { placeholder: 'Wählen Sie ein Datum und eine Uhrzeit aus', today: 'heute' }
    }
});
  • Set the culture by using the locale property.

The following example demonstrates the DateTimePicker in German culture.

<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-datetimepicker id="datetime" locale="de"></ejs-datetimepicker>
    </div>
  </div>
</template>
<script setup>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent as EjsDatetimepicker } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';


loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
  'de': {
    'datetimepicker': {
      placeholder: "Wählen Sie Datum und Uhrzeit",
      today: "heute"
    }
  }
});

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>
<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-datetimepicker id="datetime" locale="de"></ejs-datetimepicker>
    </div>
  </div>
</template>
<script>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';


loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
  'de': {
    'datetimepicker': {
      placeholder: "Wählen Sie Datum und Uhrzeit",
      today: "heute"
    }
  }
});
export default {
  name: "App",
  components: {
    "ejs-datetimepicker": DateTimePickerComponent
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>

Right-To-Left

The DateTimePicker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to displays the text in the right-to-left direction. Use enableRtl property to set the RTL direction. The following code example initialize the DateTimePicker component in Arabic culture and also explains how to set the localized text to the placeholder using load method of L10n class.

<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-datetimepicker id="datetime" :locale="locale" :enableRtl="rtl"></ejs-datetimepicker>
    </div>
  </div>
</template>
<script setup>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent as EjsDatetimepicker } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';


loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
  'ar': {
    'datetimepicker': {
      placeholder: 'حدد التاريخ والوقت',
      today: 'اليوم'
    }
  }
});

const locale = "ar";
const rtl = true;

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>
<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-datetimepicker id="datetime" :locale="locale" :enableRtl="rtl"></ejs-datetimepicker>
    </div>
  </div>
</template>
<script>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { DateTimePickerComponent } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';


loadCldr(numberingSystems, gregorian, numbers, timeZoneNames);
L10n.load({
  'ar': {
    'datetimepicker': {
      placeholder: 'حدد التاريخ والوقت',
      today: 'اليوم'
    }
  }
});
export default {
  name: "App",
  components: {
    "ejs-datetimepicker": DateTimePickerComponent
  },
  data() {
    return {
      locale: "ar",
      rtl: true
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>

Globalization in Angular DateTime Picker

25 Sep 20267 minutes to read

Globalization is the combination of internalization and localization. You can adapt the component to various languages by parsing and formatting the date or number Internationalization and also add culture specific customization and translation to the text localization.

By default, the date format, week, month, time format and meridian names are specific to the American English culture. It utilizes the Essential® JavaScript 2 Internationalization package to parse and format the date object based on the culture by using the official UNICODE CLDR JSON data. It provides the loadCldr method to load culture specific CLDR JSON data. To use a different culture other than English, follow the steps below:

  • Install the CLDR-Data package by using the following command (installs all the CLDR JSON data). To know more about CLDR-Data refer to the CLDR-Data link.
npm install cldr-data --save

Once the package installed, you can find the culture specific JSON data under the location /node_modules/cldr-data.

  • Now import the installed CLDR JSON data into the app.component.ts file.

  • Now use the loadCldr method to load the culture specific CLDR JSON data from the installed location to app.component.ts file.

  • Angular DateTime Picker displayed Sunday as the first day of week based on default culture (“en-US”). If you want to display the Angular DateTime Picker with loaded culture’s first day of week, you need to import weekdata.json file from the cldr-data/suppemental as given in the code example.

import { loadCldr } from "@syncfusion/ej2-base";

declare var require: any;

loadCldr(
  require("cldr-data/main/de/numbers.json"),
  require("cldr-data/main/de/ca-gregorian.json"),
  require("cldr-data/supplemental/numberingSystems.json"),
  require("cldr-data/main/de/timeZoneNames.json"),
  require('cldr-data/supplemental/weekdata.json') // To load the culture based first day of week
);

The Localization library allows you to localize default text content of the DateTimePicker. The DateTimePicker component has static text for today feature that can be changed to other cultures (Arabic, Deutsch, French, etc.) by defining the locale value and translation object.

Locale keywords Text
today Name of the button to choose Today date.
placeholder Hint to describe expected value in input element.
  • Before changing to a culture other than English, ensure that locale text for the concerned culture is loaded through load method of L10n class.
//Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from "@syncfusion/ej2-base";

//load the locale object to set the localized placeholder value
L10n.load({
  de: {
    datetimepicker: {
       placeholder: "Wählen Sie ein Datum und eine Uhrzeit aus",
       today:"heute"
    }
  }
});
  • Set the culture by using the locale property.
    In the following code example, the Angular DateTime Picker is initialized in German culture with corresponding localized text.

The following example demonstrates the Angular DateTime Picker in German culture.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { DateTimePickerModule } from '@syncfusion/ej2-angular-calendars'



import { Component } from "@angular/core";
import { DateTimePickerComponent } from "@syncfusion/ej2-angular-calendars";
import { loadCldr, L10n } from "@syncfusion/ej2-base";
// Here we have referred local json files for preview purpose
import * as numberingSystems from "./numberingSystems.json";
import * as gregorian from "./ca-gregorian.json";
import * as numbers from "./numbers.json";
import * as detimeZoneNames from "./timeZoneNames.json";

loadCldr(numberingSystems, gregorian, numbers, detimeZoneNames);

@Component({
imports: [
        
        DateTimePickerModule
    ],


standalone: true,
  selector: 'app-root',
  template: `<ejs-datetimepicker [value]='date' locale='de'></ejs-datetimepicker>`
})
export class AppComponent {
  public date: Date = new Date("12/11/2017 1:00 AM");
  ngOnInit(): void {
    /*loads the localization text*/
    L10n.load({
      de: {
        datetimepicker: {
          placeholder: "Wählen Sie ein Datum und eine Uhrzeit aus",
          today:"heute"
        }
      }
    });
  }
  constructor() {}
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Right-To-Left

The Angular DateTime Picker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to displays the text in the right-to-left direction.
UseenableRtl property to set the RTL direction.
The following code example initialize the Angular DateTime Picker component in Arabic culture and also explains how to set the localized text to the placeholder using load method of L10n class.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { DateTimePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from '@angular/core';
import { DateTimePickerComponent } from '@syncfusion/ej2-angular-calendars';
import { loadCldr, L10n } from '@syncfusion/ej2-base';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as artimeZoneNames from './timeZoneNames.json';

loadCldr(numberingSystems, gregorian, numbers, artimeZoneNames);

@Component({
imports: [
        
        DateTimePickerModule
    ],


standalone: true,
    selector: 'app-root',
    template: `<ejs-datetimepicker [enableRtl]='true' locale='ar'></ejs-datetimepicker>`
})

export class AppComponent {
    ngOnInit(): void {
       L10n.load({
        'ar': {
          'datetimepicker': {
              placeholder: 'حدد التاريخ والوقت',
              today: "اليوم"
          }
        }
      });
    }
    constructor() {}
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));